/***

ansi_fil.c -- illustrate ansi file usage tracking

***/

#include <ehfil.h>           /* include this instead of <eh.h> */

static void fopen_and_fclose();
static void fopen_and_no_fclose();
static void tmpfile_and_fclose();
static void tmpfile_and_no_fclose();
static void fopen_freopen_and_fclose();
static void fopen_freopen_and_no_fclose();
static void freopen_stdin_and_fclose();
static void freopen_stdin_and_no_fclose();

int
main(int argc, char**argv)
{
   EHMAIN(argc, argv) {

      int i;
      for (i = 3; i--; ) /* to illustrate pass counting */
      {
         fopen_and_fclose();
         fopen_and_no_fclose();

         tmpfile_and_fclose();
         tmpfile_and_no_fclose();

         fopen_freopen_and_fclose();
         fopen_freopen_and_no_fclose();

         freopen_stdin_and_fclose();
         freopen_stdin_and_no_fclose();
      }

   } EHENDMAIN;

   return 0;
}


static
void
fopen_and_fclose()
{
   FILE*pFile = fopen("ansi_fil.1", "w");
   if (pFile) fclose(pFile);
}


static
void
fopen_and_no_fclose()
{
   FILE *pFile = fopen("ansi_fil.2", "w");
}


static
void
tmpfile_and_fclose()
{
   FILE *pFile = tmpfile();
   if (pFile) fclose(pFile);
}


static
void
tmpfile_and_no_fclose()
{
   FILE *pFile = tmpfile();
}


static
void
fopen_freopen_and_fclose()
{
   FILE *pFile = fopen("ansi_fil.3", "w");
   pFile = freopen("ansi_fil.4", "w", pFile);
   if (pFile) fclose(pFile);
}


static
void
fopen_freopen_and_no_fclose()
{
   FILE *pFile = fopen("ansi_fil.5", "w");
   pFile = freopen("ansi_fil.6", "w", pFile);
}


static
void
freopen_stdin_and_fclose()
{
   FILE *pFile = freopen("ansi_fil.7", "w", stdin);
   if (pFile) fclose(pFile);
}


static
void
freopen_stdin_and_no_fclose()
{
   FILE *pFile = freopen("ansi_fil.8", "w", stdin);
}



