/***

lrdirent.h -- Local Resources, directory entries

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

#ifndef LRPOSIX_H
#define LRPOSIX_H 1
static const char*lrdirent_h =
       "$Id: lrdirent.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EHENV_H
#include "ehenv.h"
#endif

EHBEGINEXTERNC
#include <sys/types.h>
#include <dirent.h>
EHENDEXTERNC

#ifndef   EH_H
#include "eh.h"
#endif

/*** wrapper function prototypes ***/

DIR *_lrOpendir   A((const char *pcFil, const char *pcFun, int iLin,
                     const char *pcDirName));

void _lrClosedir A((const char *pcFil, const char *pcFun, int iLin,
                     DIR*pDir));

/*** wrapper macros ***/

#ifndef LR_NO_DIRENT_TRACKING

#define opendir(dirnam)\
 _lrOpendir(__FILE__, _EHFUNC_, __LINE__, dirnam)

#define closedir(dirp)\
 _lrClosedir(__FILE__, _EHFUNC_, __LINE__, dirp)

#endif /* LR_NO_DIRENT_TRACKING */

#endif /* LRDIRENT_H */
