/***

lrfildes.h -- Local Resources, file descriptors

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

#ifndef LRFILDES_H
#define LRFILDES_H 1
static const char*lrfildes_h =
       "$Id: lrfildes.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EHENV_H
#include "ehenv.h"
#endif

EHBEGINEXTERNC
#include <stdio.h>
EHENDEXTERNC

#ifndef   EH_H
#include "eh.h"
#endif

/*** wrapper function prototypes  ***/

int  _lrCreat A((const char *pcFil, const char *pcFun, int iLin,
                  const char *pcPath, mode_t mode));

int  _lrOpen  A((const char *pcFil, const char *pcFun, int iLin,
                  const char *pcPath, int iOFlag));

int  _lrDup   A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes));

int  _lrDup2  A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes, int iFilDes2));

void _lrClose A((const char *pcFil, const char *pcFun, int iLin,
                  int iFilDes));

/*** wrapper macros ***/

#ifndef LR_NO_FILDES_TRACKING

#define creat(path, mode)\
 _lrCreat(__FILE__, _EHFUNC_, __LINE__, path, mode)

#define open(path, flag)\
 _lrOpen(__FILE__, _EHFUNC_, __LINE__, path, flag)

#define dup(fildes)\
 _lrDup(__FILE__, _EHFUNC_, __LINE__, fildes)

#define dup2(fildes, fildes2)\
 _lrDup2(__FILE__, _EHFUNC_, __LINE__, fildes, fildes2)

#define close(fildes)\
 _lrClose(__FILE__, _EHFUNC_, __LINE__, fildes)

#endif /* LR_NO_FILDES_TRACKING */

#endif /* LRFILDES_H */
