/***

t_dirent.c -- test driver for directory entry tracking routines

***/

#include <eh.h>
#include "lrdirent.h"

static void opendir_and_closedir();
static void opendir_and_no_closedir();

int
main(int argc, char**argv)
{
   EHMAIN(argc, argv) {

      opendir_and_closedir();
      opendir_and_no_closedir();

   } EHENDMAIN;

   EHRETURN(ehError());
}


static
void
opendir_and_closedir()
{
   DIR*volatile pDir = NULL;

   EHCATCH(opendir_and_closedir) {

      pDir = opendir(".");

   } EHENDCATCH;

   if (pDir) closedir(pDir);
}


static
void
opendir_and_no_closedir()
{
   DIR*volatile pDir = NULL;
   EHTRACE(opendir_and_no_closedir);
   pDir = opendir(".");
}


