#
# bebox makefile for Error Handling library
#

ifeq "$(CC)" "gcc"
CFLAGS_P += -DNTRKMEM=1
endif

include /boot/work/swdev/include.mak

DIVSRC = ehdivsrc.$(CC)$(MODE)

ifeq "$(CC)" "mwcc"
EXENOLIBS = -o $@
EXELIBS   = -llibeh$(CC)$(MODE).a $(EXENOLIBS)
endif

ifeq "$(CC)" "cc"
EXENOLIBS = -lc -o $@
EXELIBS   = -leh$(CC)$(MODE) $(EXENOLIBS)
endif

ifeq "$(CC)" "sc"
EXENOLIBS = pname=$@
EXELIBS   = lib=libeh$(CC)$(MODE).a $(EXENOLIBS)
endif

ifeq "$(CC)" "gcc"
EXENOLIBS = -o $@
EXELIBS   = libeh$(CC)$(MODE).a $(EXENOLIBS)
endif

ifeq "$(CC)" "dcc"
EXENOLIBS = -o$@
EXELIBS   = -leh$(CC)$(MODE) $(EXENOLIBS)
endif

### all

all: eherrmsg.h $(addsuffix .$(CC)$(MODE), t_pgm t_malloc t_new t_fopen)
# m_trkmem t_pgm m_trkfio m_ctrlc)

# normal build dependencies

eherrmsg.h eherrmsg.msg : eherrmsg.src ehdivsrc.$(CC)$(MODE)
	@test -x $(DIVSRC) && $(DIVSRC) eh && echo created header eherrmsg.h

EHDIVSRC_OBJS=$(addprefix $(ENV), $(addsuffix .$(MODE).o, \
ehdivsrc ))

ehdivsrc.$(CC)$(MODE) : $(EHDIVSRC_OBJS)
	$(LD) $(LFLAGS) $(EHDIVSRC_OBJS) $(EXENOLIBS)

M_CPUTST_OBJS=$(addprefix $(ENV), $(addsuffix .$(MODE).o, \
m_cputst ehcputst))

m_cputst.$(CC)$(MODE) : $(M_CPUTST_OBJS)
	$(LD) $(LFLAGS) $(M_CPUTST_OBJS) $(EXELIBS)

T_BOUNDS_OBJS=$(addprefix $(ENV), $(addsuffix .$(MODE).o, \
t_bounds ehbounds ))

EHLIB_OBJS=$(addprefix $(ENV), $(addsuffix .$(MODE).o, \
ehfuntrc eherrlog ehresini ehchkovr ehchnvol ehperror \
ehextini ehintini ehsigint ehvolume ehcputst ehavltre \
ehlist   ehhexdmp ehbounds ehintres ehosterm ehmemtrk \
ehrestrk ehdynarr ehgtargs ehwldcrd ehfiltrk ))

try.$(CC)$(MODE) : $(ENV)try.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)try.$(MODE).o $(EXELIBS)

t_pgm.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)t_pgm.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_pgm.$(MODE).o $(EXELIBS)

t_float.$(CC)$(MODE) : $(ENV)t_float.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_float.$(MODE).o $(EXENOLIBS)

t_atexit.$(CC)$(MODE) : $(ENV)t_atexit.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_atexit.$(MODE).o $(EXENOLIBS)

t_bounds.$(CC)$(MODE) : $(T_BOUNDS_OBJS)
	$(LD) $(LFLAGS) $(T_BOUNDS_OBJS) $(EXELIBS)

m_trace.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)m_trace.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)m_trace.$(MODE).o $(EXELIBS)

t_malloc.$(CC)$(MODE):$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)t_malloc.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_malloc.$(MODE).o $(EXELIBS)

t_new.$(CC)$(MODE):$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)t_new.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_new.$(MODE).o $(EXELIBS)

t_dynarr.$(CC)$(MODE):$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)t_dynarr.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_dynarr.$(MODE).o $(EXELIBS)

t_fopen.$(CC)$(MODE):$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)t_fopen.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)t_fopen.$(MODE).o $(EXELIBS)

m_trkfio.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)m_trkfio.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)m_trkfio.$(MODE).o $(EXELIBS)

m_trkmem.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)m_trkmem.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)m_trkmem.$(MODE).o $(EXELIBS)

m_shield.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)m_shield.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)m_shield.$(MODE).o $(EXELIBS)

m_ctrlc.$(CC)$(MODE) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) $(ENV)m_ctrlc.$(MODE).o
	$(LD) $(LFLAGS) $(ENV)m_ctrlc.$(MODE).o $(EXELIBS)

# building the library

# Metrowerk's CC

ifeq "$(CC)" "mwcc"
libeh$(CC)$(MODE).a : $(EHLIB_OBJS)
	@-$(RM) libeh$(CC)$(MODE).a
	$(LIB) libeh$(CC)$(MODE).a $(EHLIB_OBJS)
endif

# Manx Aztec C

ifeq "$(CC)" "cc"
ehcc$(MODE).lib : $(EHLIB_OBJS)
	@-c:delete ehcc$(MODE).lib
	$(LIB) ehcc$(MODE).lib $(EHLIB_OBJS)
endif

# SAS C

ifeq "$(CC)" "sc"
libeh$(CC)$(MODE).a : $(EHLIB_OBJS)
	@-c:delete libeh$(CC)$(MODE).a
	$(LIB) libeh$(CC)$(MODE).a $(EHLIB_OBJS)
endif

# GNU C

ifeq "$(CC)" "gcc"
libeh$(CC)$(MODE).a : $(EHLIB_OBJS)
	@-c:delete libeh$(CC)$(MODE).a
	ar -r  libeh$(CC)$(MODE).a $(EHLIB_OBJS)
	ranlib libeh$(CC)$(MODE).a
endif

# DICE C

ifeq "$(CC)" "dcc"
ehdcc$(MODE).lib : $(EHLIB_OBJS)
	@-c:delete ehdcc$(MODE)lib
	c:join $(EHLIB_OBJS) as ehdcc$(MODE).lib
endif


### release

release:\
 eherrmsg.h\
 ../include/eh.h\
 ../include/ehenv.h\
 ../include/eherrmsg.h\
 ../include/eherrmsg.msg\
 ../lib/$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF)\
 ../bin/ehdivsrc

../include/eh.h : eh.h
	cp $? $@

../include/ehenv.h : ehenv.h
	cp $? $@

../include/eherrmsg.h : eherrmsg.h
	cp $? $@

../include/eherrmsg.msg : eherrmsg.msg
	cp $? $@

../lib/$(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF) : $(LIBPREF)eh$(CC)$(MODE).$(LIBSUFF)
	cp $? $@

../bin/ehdivsrc : ehdivsrc.$(CC)$(MODE)
	cp $? $@

### clean

clean : 
	@$(RM) "*.*c(D|P)" "*.lib" "*.a" "*.dbg" "*.lnk" "*.Err"
	@$(RM) "*/*.(D|P).o" "*.log" "*.info" "*.bak" "*.msg"
	@$(RM) "eherrmsg.h" "eherrmsg.msg" "x" "*.0??"

### realclean

realclean : clean
	dcc:bin/rcsclean
