/***

ehchkovr.h -- Error Handler, check for memory overwrites

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

#ifndef EHCHKOVR_H
#define EHCHKOVR_H 1
static const char*ehchkovr_h =
       "$Id: ehchkovr.h,v 1.4 1996/05/16 20:54:28 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EH_H
#include "eh.h"
#endif

#ifndef   EHAVLTRE_H
#include "ehavltre.h"
#endif

typedef enum 
{
   MEM_IN_USE, 
   MEM_IS_FREE
} MEMSTATE;  /* state of memory */

typedef enum 
{
   BY_NONE, 
   BY_CALLOC, 
   BY_MALLOC, 
   BY_REALLOC,
   BY_FREE 
} MEMBYWHOM; /* who freed the memory */

#define MEMLIST struct memlist_s
MEMLIST
{
   MEMLIST    *cookie;   /* self-referent address */
   void       *pvMem;    /* pointer which is returned from malloc() */
   size_t      szMem;    /* size of%ocated memory */
   const char *pcFileA;  /* source file from which memory was allocated */
   const char *pcFuncA;  /* function in which memory was allocated */
   int         iLineA;   /* line on which memory was allocated */
   MEMSTATE    nmState;  /* state of memory */
   MEMBYWHOM   nmByWhom; /* who freed the memory */
   const char *pcFileF;  /* source file in which memory was freed */
   const char *pcFuncF;  /* function in which memory was freed */
   int         iLineF;   /* line on which memory was freed */
   bool        isOvrWrt; /* has a buffer overwrite error */
};

void ehChkOvr A((const char*,const char*,const int,EHRESTRK *));

#endif /* EHCHKOVR_H */
