/***

ehfiltrk.h -- Error Handler, file stream tracking

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

#ifndef EHFILTRK_H
#define EHFILTRK_H 1
static const char*ehfiltrk_h =
       "$Id: ehfiltrk.h,v 1.2 1996/04/26 19:58:16 ccobb Exp $";

#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif

#ifndef   EH_H
#include "eh.h"
#endif

/*** file stream tracking support functions ***/

FILE *_ehFopen   A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, const char *mode));

FILE *_ehTmpFile A((const char *pcFil, const char *pcFunc, int iLin));

FILE *_ehFreopen A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, const char *mode, FILE *pFil));

void  _ehFclose  A((const char *pcFil, const char *pcFunc, int iLin,
                  FILE *pFil));

#if 0   /* non-ANSI file IO tracking is not yet implemented */

int   _ehCreat   A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, int prot));

int   _ehOpen    A((const char *pcFil, const char *pcFunc, int iLin,
                  const char *name, int mode, int prot));

int   _ehClose   A((const char *pcFil, const char *pcFunc, int iLin,
                  int filedesc));

FILE *_ehFdopen  A((const char *pcFil, const char *pcFunc, int iLin,
                  int filedesc, const char *mode));

int   _ehFileno  A((const char *pcFil, const char *pcFunc, int iLin,
                  FILE *pFile));

#endif /* non-ANSI file IO */

#ifndef EH_NFILTRK

#define fopen(name, mode)\
 _ehFopen(__FILE__, _EHFUNC_, __LINE__, name, mode)

#define tmpfile()\
 _ehTmpFile(__FILE__, _EHFUNC_, __LINE__)

#define freopen(name, mode, pFile)\
 _ehFreopen(__FILE__, _EHFUNC_, __LINE__, name, mode, pFile)

#define fclose(pFile)\
 _ehFclose(__FILE__, _EHFUNC_, __LINE__, pFile)

#if 0   /* non-ANSI file IO tracking is not yet implemented */

#define creat(name, prot)\
 _ehCreat(__FILE__, _EHFUNC_, __LINE__, name, prot)

#define open(name, mode, prot)\
 _ehOpen(__FILE__, _EHFUNC_, __LINE__, name, mode, prot)

#define close(filedesc)\
 _ehClose(__FILE__, _EHFUNC_, __LINE__, filedesc)

#define fdopen(filedesc, mode)\
 _ehFdopen(__FILE__, _EHFUNC_, __LINE__, filedesc, mode)

#ifdef fileno
#undef fileno
#endif
#define fileno(pFile)\
 ehFileno(__FILE__, _EHFUNC_, __LINE__, pFile)

#endif /* non-ANSI file IO */

#endif /* EH_NFILTRK */

#endif /* EHFILTRK_H */
