/***

ehintres.c -- Error Handler, internal resource tracking

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

static const char*rcsid =
       "$Id: ehintres.c,v 1.3 1996/01/08 17:30:26 ccobb Exp $";

#define EH_NTRKMEM 1
#include "ehintres.h"

FILENAME("ehintres.c");

EHRESTRK ehIntRes; /* internal resource tracking anchor */

/***
ehIntResInit()
Initialize internal resource tracking data structures.
***/

void
ehIntResInit(void)
{
   // puts("ehIntResInit: about to call FUN_TRACE(ehIntResInit)");

   FUN_TRACE("ehIntResInit");

   // puts("ehIntResInit: back from FUN_TRACE(ehIntResInit)");

   // puts("ehIntResInit: about to call ehResInit()");
   ehResInit(&ehIntRes);

   // puts("ehIntResInit: about to call FUN_LEAVE()");

   FUN_LEAVE();

   // puts("ehIntResInit: back from FUN_LEAVE()");

} /* ehIntResInit */


/***
ehIntResTerm()
Terminate internal resource tracking.
***/

#include "ehresini.h"
#if     TRACKING_INTERNAL_MEMORY_USE
#include <mt.h>
#endif

void
ehIntResTerm(void)
{
   FUN_TRACE("ehIntResTerm");
   ehResTerm(&ehIntRes);
#if     TRACKING_INTERNAL_MEMORY_USE
   mtChkMem();
#endif
   FUN_LEAVE();
} /* ehIntResTerm */


#include "ehintini.h"

/***
   This function pointer points to the function which
   performs internal resource initialization.  It is not
   really necessary.  The internal initialization
   function (ehIntInit()) could have been called
   directly.

   It is called through this vector so that the same
   architecture is used for internal resource initialization
   as for external resource initialization, making it easier to
   understand (or duplicate) the resource management process.
***/

void (*pfvEhIntInit)A0() = ehIntInit; /* internal initialization vector */
