/***

ehsigint.c -- Error Handler, interrupt (Control-C) signal catcher

Copyright (c) 1992-6 Christopher Cobb, All rights reserved.

***/

static const char *rcsid =
       "$Id: ehsigint.c,v 1.6 1996/05/12 15:48:52 ccobb Exp $";

#include "ehenv.h"

EHBEGINEXTERNC
#include <signal.h>
EHENDEXTERNC

#undef  EHSIMCTRLC
#include "eh.h"
#include "ehsigint.h"

FILENAME("ehsigint.c");

/***
ehSigInt()
Control-C support.
***/

void
EHCALLBACK
ehSigInt A1(int, iSig)
{
   // puts("ehSigInt: entering");

#if !ehMX || EH_CHAN
   signal(iSig, ehSigInt);
#endif
   Eh.yIntSig = 1;
   Eh.ulCtrlCIni = 0; /* no more simulated control-c's */

   // puts("ehSigInt: leaving");
}

/***

$Log: ehsigint.c,v $
 * Revision 1.6  1996/05/12  15:48:52  ccobb
 * Added Storm C support and recompiled with dcc and sasc after finishing semester project.
 *
 * Revision 1.5  1996/04/12  22:09:01  ccobb
 * From Borland C++: now requires xh support.
 *
 * Revision 1.4  1996/03/04  06:46:52  ccobb
 * This version uses only the EHSTATE structure for both current state and
 * saved states.  ehFatalJmp() and ehExitJmp() have been made separate
 * functions.  OS initialization was changed to elimiate calls to xalloc()
 * (not reliable enough) and make a linked list instead.
 *
 * Revision 1.3  1995/08/16  19:49:12  ccobb
 * Compiled with C++.
 *
 * Revision 1.2  1995/04/09  08:34:32  ccobb
 * Well, it works now!  I can't remember all the changes.
 *

***/
